/* libMatrix: Memory allocation/free library

 Bugs can be reported to yokochi@pharm.hokudai.ac.jp

 This work is a part of Olivia development project.
   http://fermi.pharm.hokudai.ac.jp/olivia/
*/

#ifndef __LIB_MATRIX__
#define __LIB_MATRIX__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <time.h>
#include <assert.h>

#ifdef __OLIVIA_IRIX__

#include <alloca.h>

#endif

float *fmalloc1d(const size_t size1);
float **fmalloc2d(const size_t size1, const size_t size2);
float ***fmalloc3d(const size_t size1, const size_t size2, const size_t size3);
float ****fmalloc4d(const size_t size1, const size_t size2, const size_t size3, const size_t size4);

void free_fmatrix1d(float *p);
void free_fmatrix2d(float **p);
void free_fmatrix3d(float ***p);
void free_fmatrix4d(float ****p);

#endif
